/************************************************
 *
 *       Filename: main.c
 *        Version: 0.2
 *         Author: little
 *     	      MSN: littlekrash@gmail.com
 *
 ***********************************************/
#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <ctype.h>
#include "fileio.h"
#include "edit.h"
//在手动编辑仙术时使用，把buf中的int型放入数组a
void makeArray(char *buf,int *a)
{
	char *end;
	while(!isdigit(*buf) && *buf) buf++;
	if(*buf) {
		*a = strtol(buf,&end,10);
		a++;
		buf = end;
	}
	while(!isdigit(*buf) && *buf) buf++;
	while(*buf) {
		*a = strtol(buf,&end,16);
		a++;
		buf = end;
		while(!isdigit(*buf) && *buf) buf++;
	}
}
//转换字符串的储存方式 C字符串到计数
void makeString(char *input,char *output)
{
	int len;
	len = strlen(input);
	STR2INT(output) = len;
	output += INTLEN;
	memcpy(output,input,len);
}
	
void dispMainMenu(){
	printf("-----------\n");
	printf("0.退出\n");
	printf("1.修改图谱\n");
	printf("2.修改装备\n");
	printf("3.修改物品\n");
	printf("4.修改仙术技能\n");
	printf("5.高级模式\n");
	printf("6.保存退出\n");
	printf("-----------\n");
	printf("请选择:");
}

void equipMenu()
{
	printf("-----------\n");
	printf("0.返回\n");
	printf("1.男用武器\n");
	printf("2.菱纱武器\n");
	printf("3.梦缡武器\n");
	printf("4.头部装备\n");
	printf("5.体部装备\n");
	printf("6.足部装备\n");
	printf("7.饰物\n");
	printf("-----------\n");
	printf("请选择:");
}
void heroMenu()
{
	printf("-----------\n");
	printf("0.返回\n");
	printf("1.天河\n");
	printf("2.菱纱\n");
	printf("3.梦缡\n");
	printf("4.紫英\n");
	printf("-----------\n");
	printf("请选择:");
}
void listTP()
{
	printf("-----------\n");
	printf("0.返回\n");
	printf("1.全部熔铸\n");
	printf("2.全部锻冶\n");
	printf("3.全部注灵\n");
	printf("4.全部图谱\n");
	printf("5.手动指定\n");
	printf("-----------\n");
	printf("请选择:");
}
void listXJ()
{
	printf("-----------\n");
	printf("0.返回\n");
	printf("1.全部水系\n");
	printf("2.全部火系\n");
	printf("3.全部风系\n");
	printf("4.全部雷系\n");
	printf("5.全部土系\n");
	printf("6.全部技能\n");
	printf("7.手动编辑\n");
	printf("-----------\n");
	printf("请选择:");
}
void listItem()
{
	printf("-----------\n");
	printf("0.返回\n");
	printf("1.全部恢复\n");
	printf("2.全部功击\n");
	printf("3.全部辅助\n");
	printf("4.全部材料\n");
	printf("5.全部剧情\n");
	printf("6.全部物品\n");
	printf("7.手动指定\n");
	printf("-----------\n");
	printf("请选择:");
}
//修改装备
void listAdvance()
{
	printf("-----------\n");
	printf("0.返回\n");
	printf("1.修改值\n");
	printf("2.修改字符串\n");
	printf("-----------\n");
	printf("请选择:");
}

void equipEdit(unsigned char type,int num)
{
	int attr[184];
	char inputBuffer[128];
	int s[6];
	int n;
	getEquipAttr(type,num,attr);

	printf("使用武器等级:\n");
	printf("天河	菱纱	梦缡	紫英\n");
	printf("%d	%d	%d	%d\n",
			attr[TH_level],attr[LS_level],attr[ML_level],attr[ZY_level]);
	fgets(inputBuffer,128,stdin);
	sscanf(inputBuffer,"%d %d %d %d",
			&attr[TH_level],&attr[LS_level],&attr[ML_level],&attr[ZY_level]);

	printf("灵蕴	潜力\n");
	printf("%d	%d\n",
			attr[LINGYUN],attr[QIANLI]);
	fgets(inputBuffer,128,stdin);
	sscanf(inputBuffer,"%d %d",
			&attr[LINGYUN],&attr[QIANLI]);

	printf("精	气	神	武	防	速	运	灵\n");
	printf("%d	%d	%d	%d	%d	%d	%d	%d\n",
			attr[JING],attr[QI],attr[SHEN],attr[WU],attr[FANG],attr[SHU],attr[YUN],attr[LING]);
	fgets(inputBuffer,128,stdin);
	sscanf(inputBuffer,"%d %d %d %d %d %d %d %d",
			&attr[JING],&attr[QI],&attr[SHEN],&attr[WU],&attr[FANG],&attr[SHU],&attr[YUN],&attr[LING]);

	printf("暴击	格档	命中	破财(0-100%%)\n");
	d2p(s,&attr[BAOJI],4);
	printf("%d	%d	%d	%d\n", s[0],s[1],s[2],s[3]);
	fgets(inputBuffer,128,stdin);
	n = sscanf(inputBuffer,"%d %d %d %d",
			&s[0],&s[1],&s[2],&s[3]);
	p2d(&attr[BAOJI],s,n);
	printf("伤害增加\n");
	printf("物理	水	火	风	雷	土\n");
	printf("%d	%d	%d	%d	%d	%d\n",
			attr[WU1],attr[SHUI1],attr[HUO1],attr[FENG1],attr[LEI1],attr[TU1]);
	fgets(inputBuffer,128,stdin);
	sscanf(inputBuffer,"%d %d %d %d %d %d",
			&attr[WU1],&attr[SHUI1],&attr[HUO4],&attr[FENG1],&attr[LEI1],&attr[TU1]);

	printf("伤害反弹(0-100%%)\n");
	printf("物理	水	火	风	雷	土\n");
	d2p(s,&attr[WU2],6);
	printf("%d	%d	%d	%d	%d	%d\n", s[0],s[1],s[2],s[3],s[4],s[5]);
	fgets(inputBuffer,128,stdin);
	n = sscanf(inputBuffer,"%d %d %d %d %d %d",
			&s[0],&s[1],&s[2],&s[3],&s[4],&s[5]);
	p2d(&attr[WU2],s,n);

	printf("伤害吸收(0-100%%)\n");
	printf("物理	水	火	风	雷	土\n");
	d2p(s,&attr[WU3],6);
	printf("%d	%d	%d	%d	%d	%d\n", s[0],s[1],s[2],s[3],s[4],s[5]);
	fgets(inputBuffer,128,stdin);
	n = sscanf(inputBuffer,"%d %d %d %d %d %d",
			&s[0],&s[1],&s[2],&s[3],&s[4],&s[5]);
	p2d(&attr[WU3],s,n);

	printf("属性增加\n");
	printf("水	火	风	雷	土\n");
	printf("%d	%d	%d	%d	%d\n",
			attr[SHUI4],attr[HUO4],attr[FENG4],attr[LEI4],attr[TU4]);
	fgets(inputBuffer,128,stdin);
	sscanf(inputBuffer,"%d %d %d %d %d",
			&attr[SHUI4],&attr[HUO4],&attr[FENG4],&attr[LEI4],&attr[TU4]);
	writeEquipAttr(type,num,attr);
}


//显示每一类装备内容
void dispEquip(unsigned char type) {
	int i,num,nameLength;
	char nameBuffer[128];
	datInfo *counter,*p;
	counter = findDatInfo(MAKE_INFO(type,COUNTER_ZB,NONE,(type + 1)));
	num = STR2INT(counter->data);
	p = counter->subLink;
	printf("-----------\n");
	printf("0.返回\n");
	for(i = 1;i <= num;i++) {
		nameLength = STR2INT(p->data + 12);
		strncpy(nameBuffer,p->data + 12 + INTLEN,nameLength);
		nameBuffer[nameLength] = '\0';
		printf("%i.%s\n",i,nameBuffer);
		p = p->subLink;
	}
	printf("-----------\n");
	printf("请选择:");
}

void caseTP(unsigned int id,unsigned char operate)
{
	unsigned char type;
	type = (id & 0xFF);
	switch (id) {
	case RONGZHU:
	case DUANYE:
	case ZHULIN:
		haveAllTP(type);
		break;
	default:
		editTP(id,operate);
		break;
	}
}

//仙术技能修改
void caseXJ()
{
	char input[128*INTLEN];
	int buf[128];
	int i,j,n;
	unsigned char type,who;
	for(;;) {
		heroMenu();
		fgets(input,128,stdin);
		sscanf(input,"%d",&who);
		if(who == 0) return;
		for(;;) {
			listXJ();
			fgets(input,128,stdin);
			sscanf(input,"%d",&type);
			if(type == 0) return;
			switch (type) {
			case WATER:
			case FIRE:
			case AIR:
			case THUNDER:
			case EARTH:
				addSerialX(type,who);
				break;
			case SKILL:
				addSerialSkill(who);
				break;
			default:
				break;
			}
			if(type == 7) {
				for(i = 1;i <= 5;i++) {
					getX(i,who,buf);
					n = buf[0];
					printf("类别：%d\n",i);
					printf("-----------\n");
					printf("计数	1	2	4	5	6\n");
					printf("%d	",n);
					if(n > 0) for(j = 1;j <= n;j++) printf("%X	",buf[j]);
					printf("\n");
					fgets(input,128*INTLEN,stdin); 
					makeArray(input,buf);
					setX(i,who,buf);
				}
				printf("类别：技能\n");
				printf("-----------\n");
				getJ(who,buf);
				n = buf[0];
				printf("计数	1	2	4	5	6	7	8	9	10	...\n");
				printf("%d	",n);
				if(n > 0) for(j = 1;j <= n;j++) printf("%X	",buf[j]);
				printf("\n");
				fgets(input,128*INTLEN,stdin); 
				makeArray(input,buf);
				setJ(who,buf);
			}
		}
	}
}

int main(int argc, char *argv[])
{
	int first;
	int id,num;
	char input[128];
	char output[128];
	char str[128];
	char *fname;
	unsigned char type;
	unsigned int who,index,op;
	int val;
	unsigned char sub;
	if(argc != 2) {
		printf("请看说明!\n");
		return EXIT_FAIL;
	}
	fname = argv[1];
	if(loadDat(fname) != EXIT_OK) {
		printf("读档错误!");
		return EXIT_FAIL;
	}
	if(initDatInfo()  != EXIT_OK) {
		printf("格式有问题?");
		return EXIT_FAIL;
	}
	if(initAllCounter() != EXIT_OK) {
		printf("格式有问题?");
		return EXIT_FAIL;
	}
	bakupFile(fname);
	for(;;) {
		dispMainMenu();
		fgets(input,128,stdin);
		sscanf(input,"%d",&first);
		switch (first) {
		case 1:
			for(;;) {
				listTP();
				fgets(input,128,stdin);
				sscanf(input,"%d",&type);
				if(type == 0) break;
				if(type >= 1 && type <= 4) haveAllTP(type);
				else {
					printf("输入图谱代码，操作码：");
					fgets(input,128,stdin);
					sscanf(input,"%x %d",&id,&op);
					editTP(id,op);
				}
			}
			break;
		case 2:
			for(;;) {
				equipMenu();
				fgets(input,128,stdin);
				sscanf(input,"%d",&sub);
				if(sub == 0) break;
				for(;;) {
					dispEquip(sub);
					fgets(input,128,stdin);
					sscanf(input,"%d",&num);
					if(num == 0 ) break;
					equipEdit(sub,num);
				}
			}
			break;
		case 3:
				for(;;) {
					listItem();
					fgets(input,128,stdin);
					sscanf(input,"%d",&first);
					if(first == 0) break;
					else if (first >= 1 && first <= 6) {
						printf("物品数量:");
						fgets(input,128,stdin);
						sscanf(input,"%d",&num);
						haveAllItem(first,num);
					}
					else if (first == 7) {
						printf("输入物品代码,数量：");
						fgets(input,128,stdin);
						sscanf(input,"%d",&id,&num);
						itemAdd(id,num);
					}
				}
				break;
		case 4:
				caseXJ();
				break;
		case 5:
				for(;;) {
					listAdvance();
					fgets(input,128,stdin);
					sscanf(input,"%d",&first);
					if(first == 0) break;
					else if(first == 1) {
						printf("输入标志索引，值:");
						fgets(input,128,stdin);
						num = sscanf(input,"%d %d %x",&who,&index,&val);
						if(num != 3) {
							printf("请看说明!\n");
							continue;
						}
						else editValue(MAKE_INFO(0,1,who,index),val);
					}
					else if(first == 2) {
						printf("输入标志索引，字符串:");
						fgets(input,128,stdin);
						num = sscanf(input,"%d %d %s",&who,&index,str);
						if(num != 3) {
							printf("请看说明!\n");
							continue;
						}
						makeString(str,output);
						editString(MAKE_INFO(0,1,who,index),output);
					}
				}
				break;
		case 6:
				saveDat(fname);
				freeDatInfo(datInfoHdr.next);
				freeFile();
				return EXIT_OK;
				break;
		case 0:
				freeDatInfo(datInfoHdr.next);
				freeFile();
				return EXIT_OK;
				break;
		}
	}
}
