/************************************************
 *
 *       Filename: search.c
 *        Version: 0.2
 *         Author: little
 *     	      MSN: littlekrash@gmail.com
 *
 ***********************************************/
#include "search.h"
void getJump(const  char *pat,int len,int *jumpTable)
{
     int  i;
     for (i = 0; i < 256; i++) jumpTable[i] = len;
     for (i = 0; i < len - 1; i++) jumpTable[(unsigned char)pat[i]] = len - i - 1;
}

int search(const char  *text,int size,const char *pat,int len)
{
     int  jumpTable[256];
     int  i, j, k;
     getJump(pat,len,jumpTable); 
     for (i = len - 1; i < size; ) { 
		 for (j = len - 1, k = i; j >= 0 && text[k] == pat[j] ; k--,j--);
          if (j < 0)          
               return k + 1;  
          else                
               i += jumpTable[(unsigned char)text[i]];
     }
     return -1;
}
